import { AggregateRoot, AggregateID } from '@mobicoop/ddd-library';
import { v4 } from 'uuid';
import {
  ConfigurationProps,
  CreateConfigurationProps,
  UpdateConfigurationProps,
} from './configuration.types';

export class ConfigurationEntity extends AggregateRoot<ConfigurationProps> {
  protected readonly _id: AggregateID;

  static create = (create: CreateConfigurationProps): ConfigurationEntity => {
    const id = v4();
    const props: ConfigurationProps = { ...create };
    const configuration = new ConfigurationEntity({ id, props });
    return configuration;
  };

  update(props: UpdateConfigurationProps): void {
    this.props.value = props.value;
  }

  validate(): void {
    // entity business rules validation to protect it's invariant before saving entity to a database
  }
}
