// All properties that a Configuration has
export interface ConfigurationProps {
  identifier: ConfigurationIdentifier;
  value: ConfigurationValue;
}

// Properties that are needed for a Configuration creation
export interface CreateConfigurationProps {
  identifier: ConfigurationIdentifier;
  value: ConfigurationValue;
}

export interface UpdateConfigurationProps {
  value: ConfigurationValue;
}

export enum ConfigurationDomain {
  CARPOOL = 'CARPOOL',
  PAGINATION = 'PAGINATION',
  USER = 'USER',
}

export type ConfigurationIdentifier = {
  domain: ConfigurationDomain;
  key: ConfigurationKey;
};

export type ConfigurationKey = string;
export type ConfigurationValue = string;

export interface CarpoolConfig {
  departureTimeMargin: number;
  role: string;
  seatsProposed: number;
  seatsRequested: number;
  strictFrequency: boolean;
}

export interface PaginationConfig {
  perPage: number;
}
